/////////////////////////////////////////////
//Funkcje konfiguracji programu Txtburn-cpp//
/////////////////////////////////////////////
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki
#include <iostream>
#include "naglowki.h"
#ifndef __WIN32__
#include <sys/io.h>   // For access().
#include <sys/types.h>  // For stat().
#include <sys/stat.h>   // For stat().
#endif

string prog_ext()
{
#ifdef __WIN32__
string prog_extend = ".exe";
#else
string prog_extend = "";
#endif
return prog_extend;
}

string portable_apps()// szczerze ta mała kupka mi już raczej nie będzie potrzebna :P
//więc to tylko od ciebie zależy co z nią zrobić:)
{
#ifdef __WIN32__
    string apps = "bin-win32\\";
#else
    string port;
    string apps;                      // tutaj zaczyna się pobieranie wartości z pliku
    ifstream portable ("config/portable");// i przekazywanie jej do zmiennej line
    if (portable.is_open())   // jeśli plik jest otwarty...
    {
        if (portable.good())    // i ma się dobrze:P...
            getline (portable,port);// to pobierze się wartość do zmiennej line
        portable.close(); // zamknie się plik
    }
    else if (!(portable.is_open()))  // a jeśli pliku nie uda się otworzyć to...
        port = "0"; // wartość zmiennej line jest równa 0
    if ((port == "0"))
        apps = "";
    else
        apps = "bin-linux/";
#endif
    return apps;
}

string txtburn_default_folder()
{
    //jak sama nazwa wskazuje funkcja ustawia domyślny folder w którym pojawią się inne foldery
#ifdef __WIN32__
    string default_folder = ""; // dla windowsa i  tak będzie to folder w którym został uruchomiony program :P
#else
    int port;
    string default_folder;
    string strPath = "bin-linux"; string env = getenv("HOME"); string strPath2 = env + "/Txtburn/";
	if (( access( strPath.c_str(), 0 ) == 0 )&&( access( strPath2.c_str(), 0) != 0))
    {
        struct stat status; struct stat status2;
        stat( strPath.c_str(), &status );
		stat( strPath2.c_str(), &status2);
        if (( status.st_mode & S_IFDIR )&&(!( status2.st_mode & S_IFDIR )))
        {
            port = 1;
        }
    }
    else
    {
        port = 0;
    }
    if ((port == 0)) // jeśli wartość jest równa zeru to domyślny folder będzie się nazywał .txtburn
 	{
        string home_variable = getenv("HOME");
        default_folder = home_variable + "/Txtburn/"; // będzie on folderem ukrytym
        vector<string>home_var; vector<string>txtburn_dir;
        home_var.push_back(home_variable); txtburn_dir.push_back("/Txtburn/");
        runprog("mkdir ","-p ", home_var,"",txtburn_dir , ""); // i dodatkowo zostanie utworzony w katalogu domowym
    }
    else  // jeśli wartość zmiennej port będzie inna niż 0 to
        default_folder = ""; // domyślnym folderem będzie ten w którym uruchomiony zostanie program
#endif
    return default_folder;
}

string txtburn_cfg_file()
{
#ifdef __WIN32__
    string txtburn_conf = "config\\txtburn.cfg";
    string null = " ";
    string dirin_str = "config";
    vector <string> dirin; dirin.push_back(dirin_str);
    vector <string> nic; nic.push_back(null);

    runprog("mkdir ", "", dirin,"", nic, "");
#else
    int port;
    string txtburn_conf;
    string strPath = "bin-linux";
	if ( access( strPath.c_str(), 0 ) == 0 )
    {
        struct stat status;
        stat( strPath.c_str(), &status );

        if ( status.st_mode & S_IFDIR )
        {
            port = 1;
        }
    }
    else
    {
        port = 0;
    }
    if ((port == 0))
    {
        string home_variable = getenv("HOME");
        txtburn_conf = home_variable + "/Txtburn/txtburn.cfg";
        vector<string>home_var; vector<string>txtburn_dir;
        home_var.push_back(home_variable); txtburn_dir.push_back("/Txtburn/");
        runprog("mkdir ","-p ", home_var,"",txtburn_dir , "");
    }
    else
    {
        vector<string>nic; vector<string>cfg_dir;
        nic.push_back(" "); cfg_dir.push_back("config");
        runprog("mkdir ", "-p ",cfg_dir,"",nic, "");
        txtburn_conf = "config/txtburn.cfg";
    }
#endif
    return txtburn_conf;
}

int konfig_iMaxspeed(int iMAXSPEED)
{
    cout << PL("Wybrałeś zmiane prędkości nagrywania\n")
         << PL("Poprosze wpisać z jaką prędkością ma zostać wypalona płyta: (od 2 do 8)\n");
    cin >> iMAXSPEED;
    cin.clear();
    cin.ignore(1000, '\n');

    if (((iMAXSPEED > 8)||(iMAXSPEED < 17))&&(!((iMAXSPEED < 9)||(iMAXSPEED > 16))))
    {
        cout << PL("\nWybrana przez ciebie prędkość nie jest zalecana\n")
             << PL("Lepiej wybrać prędkość z przedziału od 2 do 8\n");
    }
    else if (((iMAXSPEED > 8)||(iMAXSPEED < 2)))
    {
        do
        {
            cout << PL("Poprosze wpisać z jaką prędkością ma zostać wypalona płyta: (od 2 do 8)\n");
            cin >> iMAXSPEED;
            cin.clear();
            cin.ignore(1000, '\n');
            if (((iMAXSPEED > 8)||(iMAXSPEED < 17))&&(!((iMAXSPEED < 9)||(iMAXSPEED > 16))))
            {
                cout << PL("\nWybrana przez ciebie prędkość nie jest zalecana\n")
                     << PL("Lepiej wybrać prędkość z przedziału od 2 do 8\n");
                break;
            }
            else;
        }
        while (((iMAXSPEED > 8)||(iMAXSPEED < 2)));
    }
    else;

    return iMAXSPEED;
}



string konfig_naped_dvd(int ustaw, string devcdda)
{
    string apps = portable_apps();
    if (ustaw == 4)
    {
        cout << PL("Wybrałeś zmiane nagrywarki cd/dvd\n");
    }
    else if (ustaw == 15)
    {
        cout << PL("Wybrałeś zmiane napędu z płytą AudioCD\n");
    }
    else;
    cout << PL("Teraz poprosze o wpisanie nazwy tego urządzenia wejściowego\n")
         << PL("Na podstawie poniższych danych: \n");
#ifdef __WIN32__
    string command = "grep" + prog_ext();
    string null = " ";
    vector <string> prog_to_exec; prog_to_exec.push_back(command);
    vector <string> nic; nic.push_back(null);
//-----------------------------------------------------------------------------------//
    runprog("chkdrivs" + prog_ext(),  " --list | bin-win32\\", prog_to_exec," CdRom",nic, "");
//-----------------------------------------------------------------------------------//
    cout << "\n"
         << "Przyklad, jesli twoje urzadzenie to \\\\?\\Device\\CdRom0 to ty wpisujesz samo CdRom0\n"
         << "Wiec jakie to bedzie urzadzenie? : ";
#else
//-----------------------------------------------------------------------------------//
    vector <string> nic; nic.push_back(" ");
    runprog("ls -l"," /dev/",nic, " | grep sr",nic, "");
//-----------------------------------------------------------------------------------//
    cout << "\n"
         << PL("Przykład, jeśli twoje urządzenie to /dev/sr0 to ty wpisujesz samo sr0\n")
         << PL("Więc jakie to będzie urządzenie? : ");
#endif
    getline(cin, devcdda);
    cin.clear();
    cin.ignore(1000, '\n');
    return devcdda;
}

void return2default(kontenery_zmiennych_str &zmienneTxtburn)
{
    string default_folder = txtburn_default_folder();
    zmienneTxtburn.devname = devdvd;
    zmienneTxtburn.devcdda = devaudiocd;
    zmienneTxtburn.inDIRECTORY = default_folder + weDIRECTORY ;
    zmienneTxtburn.outDIRECTORY = default_folder + wyDIRECTORY ;
    zmienneTxtburn.VOLNAME = "txtburn"; // VOLNAME i ISONAME nie zostały tam z(#)definiowane
    zmienneTxtburn.ISONAME = "txtburn.iso";
    zmienneTxtburn.cdda2mp3dir = default_folder +  Cdda2mp3dir ;
    zmienneTxtburn.cdda2oggdir = default_folder +  Cdda2oggdir ;
    zmienneTxtburn.cdda2wavdir = default_folder +  Cdda2wavdir ;
    zmienneTxtburn.wav2mp3dir = default_folder +  Wav2mp3dir ;
    zmienneTxtburn.wav2oggdir = default_folder +  Wav2oggdir ;
    zmienneTxtburn.DEVICE = devdev + zmienneTxtburn.devname + "";
    zmienneTxtburn.DEVCDDA = devdev + zmienneTxtburn.devcdda + "";
    zmienneTxtburn.DIRIISO = zmienneTxtburn.outDIRECTORY + slashslash + zmienneTxtburn.ISONAME + "";
    zmienneTxtburn.MAXSPEED = "4";
    zmienneTxtburn.BUFFERSIZE = "14";
}

void about_Txtburn()
{
    clrscr();
    cout << "\n\n\tTxtburn - wersja 3.0.6 beta2 / 06//09//2012\n\n"
         << PL("\n\tTxtburn - Program do wypalania płyt CD/DVD\n")
         << PL("\tRippowania AudioCD i konwertowania do innych formatów audio\n")
         << PL("\t wav, ogg i mp3.")
         << PL("\n\tProgram został stworzony przez użytkownika forum.ubuntu.pl\n");
    cout << PL("\n\tNacisnij Enter aby zobaczyć reszte...\n") << endl;
    getchar();
    clrscr();
    cout << PL("\n\t  Hwiparam - pomysłodawca programu jak i jego twórca\n")
         << PL("\tnapisał ten program w języku bash i nazwał txtburn\n")
         << PL("\n\t  mucha090 - to jestem ja, człowiek który przeportował\n")
         << PL("\tten program do języka C++, nazwy programu nie zmienił:P\n")
         << PL("\n\t  programer1234 - pomógł w zrobieniu funkcji która wyświetla \n")
         << PL("\tznaki diakrytyczne w konsoli MS Windows\n")
         << PL("\tkontakt z w/w człowiekiem można znaleźć na cpp0x.pl/forum\n")
         << PL("\n\t  ethanak - twórca paczek na ubuntu, twórca funkcji która \n")
         << PL("\twyświetla pl znaki w wersji na linuksa :)\n")
         << PL("\n\tJeśli masz jakieś pytania/propozycje to pisz na mail:\n")
         << "\t krecik17@yahoo.pl\n\t lub pisz na forum.ubuntu.pl do ethanak lub mucha090\n\n";
    cout << PL("\n\tProsze nacisnąć Enter aby kontynuować...\n") << endl;
    getchar();
    clrscr();
}

void help_Txtburn()
{//TODO *zrobić funkcje pomocy która by pomogła w ogarnięciu tego programu*
	cout << "Witam w module pomocy Txtburn.\n";
	cout << "Aktualnie ta funkcja pomocy obsługuje następujące menu: \n"
		<< "wypalanie - jeśli to wpiszesz to pokaże tobie\n"
		<< "w jaki sposób miał(a)byś się po tym menu poruszać\n\n"
		<< "audio_ripper - jeśli to wpiszesz to pokaże tobie \n"
		<< "w jaki sposób miał(a)byś się po tym menu poruszać\n\n";
		
}
