//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki
#include <iostream> // plik który zawiera dwie zmienne które mają za zadanie wyświetlić na ekranie konsoli
#include <string>   // polskie znaki, pierwsza jest na system windows a druga na linux/unix/*nix
#include "naglowki.h"
#ifdef __WIN32__
// Win32 only | Działa tylko na Windowsie
// funkcja pokazuje polskie znaki diakrytyczne
string PL(string text)
{
   int array_length = 18; //długość tablic array i nr, musi być prawidłowa, tutaj wpisałem ją na sztywno
   string array[] = {"ą", "ć", "ę", "ł", "ń", "ó", "ś", "ź", "ż", "Ą", "Ć", "Ę", "Ł", "Ń", "Ó", "Ś", "Ź", "Ż"};
   int nr[] = {165, 134, 169, 136, 228, 162, 152, 171, 190, 164, 143, 168, 157, 227, 224, 151, 141, 189};
   for(int i = 0; i < array_length; i++)
   {
      string separator = array[i]; //kolejna polska litera
      unsigned int pos = -1;
      while((pos = text.find(separator)) != string::npos) //sytuacja pozwala na przeszukiwanie tekstu od zera
      {
         string ch;
         ch = char(nr[i]);
         text.replace(pos, 2, ch); //2 znaki - ponieważ polski znak zajmuje w pamięci 2 bajty
      }
   }
   return text;
}
#else
//TODO func for linux to make polish characters
#include <stdlib.h>
#include <string.h>
#include <iconv.h>
extern char terminal_charset[64];

static char *convert_s(const char *str)
{
	iconv_t ic=iconv_open(terminal_charset,"UTF-8");
	char *ostr=(char *)malloc(6*strlen(str)+1);
	char *obuf=ostr;
	size_t inlen,outlen;
	inlen=strlen(str);
	outlen=6*inlen;
	iconv(ic,(char **)&str,&inlen,&ostr,&outlen);
	*ostr=0;
	iconv_close(ic);
	return obuf;
}

string PL(string tekst)
{
    if (!terminal_charset[0]) {
		return tekst;
	}
	char *buf=convert_s(tekst.c_str());
	string outekst=string(buf);
	free(buf);
	return outekst;
}
#endif
