#ifndef uruchom_program_h
#define uruchom_program_h

#include <cstdlib>
#include <iostream>
#include <vector>
#include <utility>
#include <string>

#ifndef __WIN32__
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#endif
// define list is below
#ifdef __WIN32__
#define Cdda2ogg "cdda2ogg.exe"
#define Cdda2mp3 "cdda2mp3.exe"
#else
#define Cdda2ogg "cdda2ogg"
#define Cdda2mp3 "cdda2mp3"
#endif

using namespace std;

typedef pair<string,string> pr;

int czyProgIstnieje(string programname);
string ripp_ext(string programname);
string prog_ext();

string programs(string programparams1, vector<pr> dirin, string programparams2, vector<pr> dirout, string programparams3);
#ifdef __WIN32__
void runprog(string programname, string programparams1, vector<string> dirin, string programparams2, vector<string> dirout, string programparams3);
#else
int runprog(string programname, string programparams1, vector<string> dirin, string programparams2, vector<string> dirout, string programparams3);
#endif

#endif
