//The documentation about license is in license-gpl-2.0.txt
//This is a part of program Txtburn-cpp
//and Txtburn-cpp was written by Michał "mucha090" Kubicki
#include <iostream>
#include "naglowki.h"
#ifdef __WIN32__
#include <conio.h>
#include <windows.h>
//funkcja do czyszczenia ekranu pod system windows
// funkcja została zapożyczona z forum cplusplus.com
void clrscr()
  {
  HANDLE                     hStdOut;
  CONSOLE_SCREEN_BUFFER_INFO csbi;
  DWORD                      count;
  DWORD                      cellCount;
  COORD                      homeCoords = { 0, 0 };

  hStdOut = GetStdHandle( STD_OUTPUT_HANDLE );
  if (hStdOut == INVALID_HANDLE_VALUE) return;

  /* Get the number of cells in the current buffer */
  if (!GetConsoleScreenBufferInfo( hStdOut, &csbi )) return;
  cellCount = csbi.dwSize.X *csbi.dwSize.Y;

  /* Fill the entire buffer with spaces */
  if (!FillConsoleOutputCharacter(
    hStdOut,
    (TCHAR) ' ',
    cellCount,
    homeCoords,
    &count
    )) return;

  /* Fill the entire buffer with the current colors and attributes */
  if (!FillConsoleOutputAttribute(
    hStdOut,
    csbi.wAttributes,
    cellCount,
    homeCoords,
    &count
    )) return;

  /* Move the cursor home */
  SetConsoleCursorPosition( hStdOut, homeCoords );
  }
#else
#include <term.h>
#include <curses.h>
#include <unistd.h>
// funkcja do czyszczenia ekranu na linuxa
// funkcja została zapożyczona z forum cplusplus.com
void clrscr()
  {
  if (!cur_term)
    {
    int result;
    setupterm( NULL, STDOUT_FILENO, &result );
    if (result <= 0) return;
    }

  putp( tigetstr( "clear" ) );
  }
#endif
