#include <iostream>
#include "naglowki.h"
//The documentation about license is in license-gpl-2.0.txt
//This program was written in 2012 by Michał "mucha090" Kubicki
void ustaw_programu(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{
    string txtburn_conf = txtburn_cfg_file();
    stringstream int2string, int2string2; stringstream string2int, string2int2;
//---------------------------------------------------------------//
    string devname = zmienneTxtburn.devname;
    string devcdda = zmienneTxtburn.devcdda;
    string inDIRECTORY = zmienneTxtburn.inDIRECTORY;
    string outDIRECTORY = zmienneTxtburn.outDIRECTORY;
    string VOLNAME = zmienneTxtburn.VOLNAME;
    string ISONAME = zmienneTxtburn.ISONAME;
    string cdda2mp3dir = zmienneTxtburn.cdda2mp3dir;
    string cdda2oggdir = zmienneTxtburn.cdda2oggdir;
    string cdda2wavdir = zmienneTxtburn.cdda2wavdir;
    string wav2mp3dir = zmienneTxtburn.wav2mp3dir;
    string wav2oggdir = zmienneTxtburn.wav2oggdir;
    string DEVICE = zmienneTxtburn.DEVICE;
    string DEVCDDA = zmienneTxtburn.DEVCDDA;
    string DIRIISO = zmienneTxtburn.DIRIISO;
    string MAXSPEED = zmienneTxtburn.MAXSPEED;
    string BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
//---------------------------------------------------------------//

    int ustaw;
    do
    {
        //clrscr(); //menu edycji zmiennych w programie
        cout << PL("\nTutaj jest główne menu do konfiguracji ustawień programu.\n")
             << PL("Teraz prosze, wybierz jedną z poniższych opcji: \n")
             << PL("1 - Wypalanie plików \n");
#ifndef __WIN32__             
		cout << "2 - Rippowanie AudioCD i konwersja \n";
#endif
        cout << PL("6 - Przywrócenie ustawień domyślnych programu\n")
             << PL("7 - Wczytanie konfiguracji z pliku\n")
             << PL("8 - Zapis konfiguracji do pliku\n")
             << PL("9 - Wyjście do menu głównego\n")
             << PL("0 - Wyjście z programu\n\n");
        cin >> ustaw;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, ustaw);
        switch (ustaw)
        {
        case 1:
        {
            clrscr();
        ust_wypalanie(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            break;
        }
#ifndef __WIN32__
        case 2:
        {
            clrscr();
		ust_ripp(iMAXSPEED, iBUFFERSIZE, zmienneTxtburn);
            break;
        }
#endif
        case 6:
        { // przywrócenie domyślnych zmiennych
            clrscr();
            return2default(zmienneTxtburn);
//---------------------------------------------------------------//
            MAXSPEED = zmienneTxtburn.MAXSPEED;
            BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
            stringstream string2int(MAXSPEED);
            stringstream string2int2(BUFFERSIZE);
            string2int >> iMAXSPEED;
            string2int2 >> iBUFFERSIZE;
//---------------------------------------------------------------//
            break;
        }
        case 7:
        {
            // wczytanie zmiennych z pliku
            clrscr();
            file2string(zmienneTxtburn);
//---------------------------------------------------------------//
            MAXSPEED = zmienneTxtburn.MAXSPEED;
            BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
            stringstream string2int(MAXSPEED);
            stringstream string2int2(BUFFERSIZE);
            string2int >> iMAXSPEED;
            string2int2 >> iBUFFERSIZE;
//---------------------------------------------------------------//
            break;
        }
        case 8:
        {
            // zapis zmiennych do pliku
            clrscr();
//---------------------------------------------------------------//
            int2string.clear();
            int2string.str("");
            int2string2.clear();
            int2string2.str("");
            zmienneTxtburn.MAXSPEED.clear();
            zmienneTxtburn.BUFFERSIZE.clear();
            int2string << iMAXSPEED;
            int2string2 << iBUFFERSIZE;
            zmienneTxtburn.MAXSPEED = int2string.str();
            zmienneTxtburn.BUFFERSIZE = int2string2.str();
//---------------------------------------------------------------//
            save2file(zmienneTxtburn);
            break;
        }
        case 9:
		{
        break;
		}
        case 0:
        {
            clrscr();
            cout << "Do widzenia\n";
            //return 0;
            exit(0);
            break;
        }
        default:
        {
            clrscr();
            cout << "\tError 404. Page not found.\n";
            break;
        }
        }
    }
    while (!(ustaw == 9));
}

void ust_wypalanie(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{//TODO *dokończyć tą funkcje*
//---------------------------------------------------------------//
	stringstream int2string, int2string2; stringstream string2int, string2int2;
	string devname = zmienneTxtburn.devname;
    string DIRIISO = zmienneTxtburn.DIRIISO;
    string MAXSPEED = zmienneTxtburn.MAXSPEED;
    string BUFFERSIZE = zmienneTxtburn.BUFFERSIZE;
    string inDIRECTORY = zmienneTxtburn.inDIRECTORY;
    string outDIRECTORY = zmienneTxtburn.outDIRECTORY;
    string VOLNAME = zmienneTxtburn.VOLNAME;
    string ISONAME = zmienneTxtburn.ISONAME;
	string DEVICE = zmienneTxtburn.DEVICE;
//---------------------------------------------------------------//    
int wyp_ust;
char pytanie;
do
{        
		cout << PL("\nPoniżej są ustawienia do\n wypalania płyt cd (i ich wartości)\n")
             << PL("Teraz prosze, wybierz jedną z poniższych opcji: (default / aktualna) \n\n");
        cout << PL("\t1 - Katalog z plikami do nagrania \n (")<<weDIRECTORY<<" / "<<inDIRECTORY<<")\n"
             << PL("\t2 - Katalog z obrazem iso \n (")<<wyDIRECTORY<<" / "<<outDIRECTORY<<")\n"
             << PL("\t3 - Nazwa pliku iso \n (txtburn.iso / ")<<ISONAME<<")\n"
             << "\t4 - Nagrywarka cd/dvd \n ("<<devdev<<devdvd<< " / " <<devdev<<devname<<")\n"
             << PL("\t5 - Nazwa płyty \n (txtburn / ")<<VOLNAME<<")\n"
             << PL("\t6 - Prędkość wypalania płyt \n (4 / ")<<iMAXSPEED<<")\n\n";
		cout << PL("\t9 - Wyjście do menu ustawień programu.\n");
		cin >> wyp_ust;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, wyp_ust);
        switch (wyp_ust)
        {
        case 1:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami do nagrania\n")
                 << PL("Teraz poprosze o wpisanie pełnej nazwy katalogu\n");
            getline(cin, inDIRECTORY);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 2:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z obrazem iso\n")
                 << PL("Teraz poprosze o wpisanie pełnej nazwy katalogu\n");
            getline(cin, outDIRECTORY);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 3:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane nazwy pliku iso\n")
                 << PL("Teraz poprosze o wpisanie tej nazwy\n");
            getline(cin, ISONAME);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 4:
        {
            clrscr();
            cout << "\n";
            devname = konfig_naped_dvd(wyp_ust, devname);
            cout << "\n";
            break;
        }
        case 5:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane nazwy płyty\n")
                 << PL("Teraz poprosze o wpisanie tej nazwy\n");
            getline(cin, VOLNAME);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 6:
        {
            clrscr();
            cout << "\n";
            iMAXSPEED = konfig_iMaxspeed(iMAXSPEED);
            cout << "\n";
            break;
        }
        case 9:
        {
            //clrscr();
            cout << PL("\n\n\tCzy chcesz zaktualizować konfiguracje? (T/N)\n");
            cin >> pytanie;
            cin.clear();
            cin.ignore(1000, '\n');
            cout << "\n\n";
            if ((pytanie == 'T')||(pytanie == 't'))
            {
//---------------------------------------------------------------//
                //clrscr();
                cout << PL("Akutalizacja konfiguracji ogólnej....: ");
//zapis konfiguracji ogólnej
                zmienneTxtburn.inDIRECTORY = inDIRECTORY;
                zmienneTxtburn.outDIRECTORY = outDIRECTORY;
                zmienneTxtburn.devname = devname;
                zmienneTxtburn.DEVICE = devdev + devname + "";
                cout << "OK \n";
                cout << PL("Aktualizacja konfiguracji do wypalania płyt CD/DVD....: ");
//zapis konfiguracji wypalania płyt CD/DVD
                zmienneTxtburn.VOLNAME = VOLNAME;
                zmienneTxtburn.ISONAME = ISONAME;
                zmienneTxtburn.DIRIISO = outDIRECTORY + slashslash + ISONAME + "";
                int2string.clear();
                int2string.str("");
                int2string2.clear();
                int2string2.str("");
                zmienneTxtburn.MAXSPEED.clear();
                zmienneTxtburn.BUFFERSIZE.clear();
                int2string << iMAXSPEED;
                int2string2 << iBUFFERSIZE;
                zmienneTxtburn.MAXSPEED = int2string.str();
                zmienneTxtburn.BUFFERSIZE = int2string2.str();
                cout << "OK \n";
                cout << PL("Tworzenie potrzebnych katalogów.....: ");
//tworzenie katalogów z uprzednio wyedytowanych zmiennych
                string makedir = inDIRECTORY + " " + outDIRECTORY + "";
                string null = " ";
                vector <string> Makedir; Makedir.push_back(makedir);
                vector <string> nic; nic.push_back(null);
                runprog(MKdir, "",Makedir, "", nic, "");
                makedir.clear();
                cout << "OK \n";
                cout << PL("Ustawienia zostały pomyślnie zaktualizowane :) \nNaciśnij Enter aby kontynuować\n");
                getchar();
            }
            else;
            clrscr();
            break;
        }
				
		default:
        {
            clrscr();
            cout << "\tError 404. Page not found.\n";
            break;
        }
        }
    }
    while (!(wyp_ust == 9));
}

void ust_ripp(int &iMAXSPEED, int &iBUFFERSIZE, kontenery_zmiennych_str &zmienneTxtburn)
{//TODO *dokończyć tą funkcje*
//---------------------------------------------------------------//
    stringstream int2string, int2string2; stringstream string2int, string2int2;
	string cdda2mp3dir = zmienneTxtburn.cdda2mp3dir;
    string cdda2oggdir = zmienneTxtburn.cdda2oggdir;
    string cdda2wavdir = zmienneTxtburn.cdda2wavdir;
    string wav2mp3dir = zmienneTxtburn.wav2mp3dir;
    string wav2oggdir = zmienneTxtburn.wav2oggdir;    
	string devcdda = zmienneTxtburn.devcdda;
    string DEVCDDA = zmienneTxtburn.DEVCDDA;
//---------------------------------------------------------------//
int rip_ust;
char pytanie;
do
{ 
		cout << PL("\nPoniżej są ustawienia do\n rippowania płyt cd (i ich wartości)\n")
             << PL("Teraz prosze, wybierz jedną z poniższych opcji: (default / aktualna) \n\n");
        cout << PL("\t10 - Katalog z plikami wav po AudioCD-rip \n (")<<Cdda2wavdir<<" / "<<cdda2wavdir<<")\n"
             << PL("\t11 - Katalog z plikami ogg po AudioCD-rip \n (")<<Cdda2oggdir<<" / "<<cdda2oggdir<<")\n"
             << PL("\t12 - Katalog z plikami mp3 po AudioCD-rip \n (")<<Cdda2mp3dir<<" / "<<cdda2mp3dir<<")\n"
             << PL("\t13 - Katalog z plikami ogg po konwersji z wav \n (")<<Wav2oggdir<<" / "<<wav2oggdir<<")\n"
             << PL("\t14 - Katalog z plikami mp3 po konwersji z wav \n (")<<Wav2mp3dir<<" / "<<wav2mp3dir<<")\n"
             << PL("\t15 - Napęd z płytą AudioCD \n (")<<devdev<<devaudiocd<< " / " <<devdev<<devcdda<<")\n\n";
		cout << PL("\t9 - Wyjście do menu ustawień programu.\n");
		cin >> rip_ust;
        bool czyDobrze = cin.good();
        cin.clear();
        cin.ignore(1000, '\n');
        blokada(czyDobrze, rip_ust);
        switch (rip_ust)
        {
        case 10:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami wav po AudioCD-rip \n")
                 << PL("A teraz poprosze ciebie abyś wpisał nową ścieżke: ");
            getline(cin, cdda2wavdir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 11:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami ogg po AudioCD-rip \n")
                 << PL("A teraz poprosze ciebie abyś wpisał nową ścieżke: ");
            getline(cin, cdda2oggdir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 12:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami mp3 po AudioCD-rip \n")
                 << PL("A teraz poprosze ciebie abyś wpisał nową ścieżke: ");
            getline(cin, cdda2mp3dir);
            cin.clear();
            cin.ignore(1000, '\n');
            break;
        }
        case 13:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami ogg po konwersji z wav \n")
                 << PL("A teraz poprosze ciebie abyś wpisał nową ścieżke: ");
            getline(cin, wav2oggdir);
            cin.clear();
            cin.ignore(1000, '\n');

            break;
        }
        case 14:
        {
            clrscr();
            cout << PL("Wybrałeś zmiane katalogu z plikami mp3 po konwersji z wav \n")
                 << PL("A teraz poprosze ciebie abyś wpisał nową ścieżke: ");
            getline(cin, wav2mp3dir);
            cin.clear();
            cin.ignore(1000, '\n');

            break;
        }
        case 15:
        {
            clrscr();
            cout << "\n";
            devcdda = konfig_naped_dvd(rip_ust, devcdda);
            cout << "\n";
            break;
        }
        case 9:
        {
            //clrscr();
            cout << PL("\n\n\tCzy chcesz zaktualizować konfiguracje? (T/N)\n");
            cin >> pytanie;
            cin.clear();
            cin.ignore(1000, '\n');
            cout << "\n\n";
            if ((pytanie == 'T')||(pytanie == 't'))
            {
//---------------------------------------------------------------//
                //clrscr();
                cout << PL("Akutalizacja konfiguracji ogólnej....: ");
//zapis konfiguracji ogólnej
              /*  zmienneTxtburn.inDIRECTORY = inDIRECTORY;
                zmienneTxtburn.outDIRECTORY = outDIRECTORY;
                zmienneTxtburn.devname = devname;
                zmienneTxtburn.DEVICE = devdev + devname + "";*/
                cout << "OK \n";
                cout << PL("Aktualizacja konfiguracji do rippowania płyt....: ");
//zapis konfiguracji rippowania płyt
                zmienneTxtburn.devcdda = devcdda;
                zmienneTxtburn.DEVCDDA = devdev + devcdda + "";
                zmienneTxtburn.cdda2mp3dir = cdda2mp3dir;
                zmienneTxtburn.cdda2oggdir = cdda2oggdir;
                zmienneTxtburn.cdda2wavdir = cdda2wavdir;
                zmienneTxtburn.wav2mp3dir = wav2mp3dir;
                zmienneTxtburn.wav2oggdir = wav2oggdir;
                cout << "OK \n";
                cout << PL("Tworzenie potrzebnych katalogów.....: ");
//tworzenie katalogów z uprzednio wyedytowanych zmiennych
                string makedir = cdda2mp3dir + " " + cdda2oggdir + " " + cdda2wavdir + " " + wav2mp3dir + " " + wav2oggdir + "";
                string null = " ";
                vector <string> Makedir; Makedir.push_back(makedir);
                vector <string> nic; nic.push_back(null);
                runprog(MKdir, "",Makedir, "", nic, "");
                makedir.clear();
                cout << "OK \n";
                cout << PL("Ustawienia zostały pomyślnie zaktualizowane :) \nNaciśnij Enter aby kontynuować\n");
                getchar();
            }
            else;
            clrscr();
            break;
        }
        default:
        {
            clrscr();
            cout << "\tError 404. Page not found.\n";
            break;
        }
        }
    }
    while (!(rip_ust == 9));
}
